diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximasel.cpp ./win32/dependencies/cximage/ximasel.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximasel.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximasel.cpp	2006-08-24 07:16:03 +0900
@@ -0,0 +1,469 @@
+// xImaSel.cpp : Selection functions
+/* 07/08/2001 v1.00 - Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_SELECTION
+
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Checks if the image has a valid selection.
+ */
+bool CxImage::SelectionIsValid()
+{
+	return pSelection!=0;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Gets the smallest rectangle that contains the selection 
+ */
+void CxImage::SelectionGetBox(RECT& r)
+{
+	memcpy(&r,&info.rSelectionBox,sizeof(RECT));
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Empties the selection.
+ */
+bool CxImage::SelectionClear()
+{
+	if (pSelection){
+		memset(pSelection,0,head.biWidth * head.biHeight);
+		info.rSelectionBox.left = head.biWidth;
+		info.rSelectionBox.bottom = head.biHeight;
+		info.rSelectionBox.right = info.rSelectionBox.top = 0;
+		return true;
+	}
+	return false;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Allocates an empty selection.
+ */
+bool CxImage::SelectionCreate()
+{
+	SelectionDelete();
+	pSelection = (BYTE*)calloc(head.biWidth * head.biHeight, 1);
+	return (pSelection!=0);
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Deallocates the selction.
+ */
+bool CxImage::SelectionDelete()
+{
+	if (pSelection){ free(pSelection); pSelection=NULL; }
+	info.rSelectionBox.left = head.biWidth;
+	info.rSelectionBox.bottom = head.biHeight;
+	info.rSelectionBox.right = info.rSelectionBox.top = 0;
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Checks if the coordinates are inside the selection.
+ */
+bool CxImage::SelectionIsInside(long x, long y)
+{
+	if (IsInside(x,y)){
+		if (pSelection==NULL) return true;
+		return pSelection[x+y*head.biWidth]!=0;
+	}
+	return false;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Adds a rectangle to the existing selection.
+ */
+bool CxImage::SelectionAddRect(RECT r)
+{
+	if (pSelection==NULL) SelectionCreate();
+	if (pSelection==NULL) return false;
+
+	RECT r2;
+	if (r.left<r.right) {r2.left=r.left; r2.right=r.right; } else {r2.left=r.right ; r2.right=r.left; }
+	if (r.bottom<r.top) {r2.bottom=r.bottom; r2.top=r.top; } else {r2.bottom=r.top ; r2.top=r.bottom; }
+
+	if (info.rSelectionBox.top < r2.top) info.rSelectionBox.top = max(0L,min(head.biHeight,r2.top));
+	if (info.rSelectionBox.left > r2.left) info.rSelectionBox.left = max(0L,min(head.biWidth,r2.left));
+	if (info.rSelectionBox.right < r2.right) info.rSelectionBox.right = max(0L,min(head.biWidth,r2.right));
+	if (info.rSelectionBox.bottom > r2.bottom) info.rSelectionBox.bottom = max(0L,min(head.biHeight,r2.bottom));
+
+	long ymin = max(0L,min(head.biHeight,r2.bottom));
+	long ymax = max(0L,min(head.biHeight,r2.top));
+	long xmin = max(0L,min(head.biWidth,r2.left));
+	long xmax = max(0L,min(head.biWidth,r2.right));
+
+	for (long y=ymin; y<ymax; y++)
+		memset(pSelection + xmin + y * head.biWidth, 255, xmax-xmin);
+
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Adds an ellipse to the existing selection.
+ */
+bool CxImage::SelectionAddEllipse(RECT r)
+{
+	if (pSelection==NULL) SelectionCreate();
+	if (pSelection==NULL) return false;
+
+	long xradius = abs(r.right - r.left)/2;
+	long yradius = abs(r.top - r.bottom)/2;
+	if (xradius==0 || yradius==0) return false;
+
+	long xcenter = (r.right + r.left)/2;
+	long ycenter = (r.top + r.bottom)/2;
+
+	if (info.rSelectionBox.left > (xcenter - xradius)) info.rSelectionBox.left = max(0L,min(head.biWidth,(xcenter - xradius)));
+	if (info.rSelectionBox.right < (xcenter + xradius)) info.rSelectionBox.right = max(0L,min(head.biWidth,(xcenter + xradius)));
+	if (info.rSelectionBox.bottom > (ycenter - yradius)) info.rSelectionBox.bottom = max(0L,min(head.biHeight,(ycenter - yradius)));
+	if (info.rSelectionBox.top < (ycenter + yradius)) info.rSelectionBox.top = max(0L,min(head.biHeight,(ycenter + yradius)));
+
+	long xmin = max(0L,min(head.biWidth,xcenter - xradius));
+	long xmax = max(0L,min(head.biWidth,xcenter + xradius));
+	long ymin = max(0L,min(head.biHeight,ycenter - yradius));
+	long ymax = max(0L,min(head.biHeight,ycenter + yradius));
+
+	long y,yo;
+	for (y=ymin; y<ycenter; y++){
+		for (long x=xmin; x<xmax; x++){
+			yo = (long)(ycenter - yradius * sqrt(1-pow((float)(x - xcenter)/(float)xradius,2)));
+			if (yo<y) pSelection[x + y * head.biWidth] = 255;
+		}
+	}
+	for (y=ycenter; y<ymax; y++){
+		for (long x=xmin; x<xmax; x++){
+			yo = (long)(ycenter + yradius * sqrt(1-pow((float)(x - xcenter)/(float)xradius,2)));
+			if (yo>y) pSelection[x + y * head.biWidth] = 255;
+		}
+	}
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Inverts the selection.
+ */
+bool CxImage::SelectionInvert()
+{
+	if (pSelection) {
+		BYTE *iSrc=pSelection;
+		long n=head.biHeight*head.biWidth;
+		for(long i=0; i < n; i++){
+			*iSrc=(BYTE)~(*(iSrc));
+			iSrc++;
+		}
+		return true;
+	}
+	return false;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Imports an existing region from another image with the same width and height.
+ */
+bool CxImage::SelectionCopy(CxImage &from)
+{
+	if (from.pSelection == NULL || head.biWidth != from.head.biWidth || head.biHeight != from.head.biHeight) return false;
+	if (pSelection==NULL) pSelection = (BYTE*)malloc(head.biWidth * head.biHeight);
+	if (pSelection==NULL) return false;
+	memcpy(pSelection,from.pSelection,head.biWidth * head.biHeight);
+	memcpy(&info.rSelectionBox,&from.info.rSelectionBox,sizeof(RECT));
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Adds a polygonal region to the existing selection. points points to an array of POINT structures.
+ * Each structure specifies the x-coordinate and y-coordinate of one vertex of the polygon.
+ * npoints specifies the number of POINT structures in the array pointed to by points.
+ */
+bool CxImage::SelectionAddPolygon(POINT *points, long npoints)
+{
+	if (points==NULL || npoints<3) return false;
+
+	if (pSelection==NULL) SelectionCreate();
+	if (pSelection==NULL) return false;
+
+	BYTE* plocal = (BYTE*)calloc(head.biWidth*head.biHeight, 1);
+	RECT localbox = {head.biWidth,0,0,head.biHeight};
+
+	long x,y,i=0;
+	POINT *current,*next,*start;
+	//trace contour
+	while (i < npoints){
+		current = &points[i];
+		if (current->x!=-1){
+			if (i==0 || (i>0 && points[i-1].x==-1)) start = &points[i];
+
+			if ((i+1)==npoints || points[i+1].x==-1)
+				next = start;
+			else
+				next = &points[i+1];
+
+			float beta;
+			if (current->x != next->x){
+				beta = (float)(next->y - current->y)/(float)(next->x - current->x);
+				if (current->x < next->x){
+					for (x=current->x; x<=next->x; x++){
+						y = (long)(current->y + (x - current->x) * beta);
+						if (IsInside(x,y)) plocal[x + y * head.biWidth] = 255;
+					}
+				} else {
+					for (x=current->x; x>=next->x; x--){
+						y = (long)(current->y + (x - current->x) * beta);
+						if (IsInside(x,y)) plocal[x + y * head.biWidth] = 255;
+					}
+				}
+			}
+			if (current->y != next->y){
+				beta = (float)(next->x - current->x)/(float)(next->y - current->y);
+				if (current->y < next->y){
+					for (y=current->y; y<=next->y; y++){
+						x = (long)(current->x + (y - current->y) * beta);
+						if (IsInside(x,y)) plocal[x + y * head.biWidth] = 255;
+					}
+				} else {
+					for (y=current->y; y>=next->y; y--){
+						x = (long)(current->x + (y - current->y) * beta);
+						if (IsInside(x,y)) plocal[x + y * head.biWidth] = 255;
+					}
+				}
+			}
+		}
+
+		RECT r2;
+		if (current->x < next->x) {r2.left=current->x; r2.right=next->x; } else {r2.left=next->x ; r2.right=current->x; }
+		if (current->y < next->y) {r2.bottom=current->y; r2.top=next->y; } else {r2.bottom=next->y ; r2.top=current->y; }
+		if (localbox.top < r2.top) localbox.top = max(0L,min(head.biHeight-1,r2.top+1));
+		if (localbox.left > r2.left) localbox.left = max(0L,min(head.biWidth-1,r2.left-1));
+		if (localbox.right < r2.right) localbox.right = max(0L,min(head.biWidth-1,r2.right+1));
+		if (localbox.bottom > r2.bottom) localbox.bottom = max(0L,min(head.biHeight-1,r2.bottom-1));
+
+		i++;
+	}
+
+	//fill the outer region
+	long npix=(localbox.right - localbox.left)*(localbox.top - localbox.bottom);
+	POINT* pix = (POINT*)calloc(npix,sizeof(POINT));
+	BYTE back=0, mark=1;
+	long fx, fy, fxx, fyy, first, last,xmin,xmax,ymin,ymax;
+
+	for (int side=0; side<4; side++){
+		switch(side){
+		case 0:
+			xmin=localbox.left; xmax=localbox.right+1; ymin=localbox.bottom; ymax=localbox.bottom+1;
+			break;
+		case 1:
+			xmin=localbox.right; xmax=localbox.right+1; ymin=localbox.bottom; ymax=localbox.top+1;
+			break;
+		case 2:
+			xmin=localbox.left; xmax=localbox.right+1; ymin=localbox.top; ymax=localbox.top+1;
+			break;
+		case 3:
+			xmin=localbox.left; xmax=localbox.left+1; ymin=localbox.bottom; ymax=localbox.top+1;
+			break;
+		}
+		//fill from the border points
+		for(y=ymin;y<ymax;y++){
+			for(x=xmin;x<xmax;x++){
+				if (plocal[x+y*head.biWidth]==0){
+					// Subject: FLOOD FILL ROUTINE              Date: 12-23-97 (00:57)       
+					// Author:  Petter Holmberg                 Code: QB, QBasic, PDS        
+					// Origin:  petter.holmberg@usa.net         Packet: GRAPHICS.ABC
+					first=0;
+					last=1;
+					while(first!=last){
+						fx = pix[first].x;
+						fy = pix[first].y;
+						fxx = fx + x;
+						fyy = fy + y;
+						do {
+							if ((plocal[fxx + fyy*head.biWidth] == back) &&
+								fxx>=localbox.left && fxx<=localbox.right && fyy>=localbox.bottom && fyy<=localbox.top )
+							{
+								plocal[fxx + fyy*head.biWidth] = mark;
+								if (fyy > 0 && plocal[fxx + (fyy - 1)*head.biWidth] == back){
+									pix[last].x = fx;
+									pix[last].y = fy - 1;
+									last++;
+									if (last == npix) last = 0;
+								}
+								if ((fyy + 1)<head.biHeight && plocal[fxx + (fyy + 1)*head.biWidth] == back){
+									pix[last].x = fx;
+									pix[last].y = fy + 1;
+									last++;
+									if (last == npix) last = 0;
+								}
+							} else {
+								break;
+							}
+							fx++;
+							fxx++;
+						} while(1);
+
+						fx = pix[first].x - 1;
+						fy = pix[first].y;
+						fxx = fx + x;
+						fyy = fy + y;
+
+						do {
+							if ((plocal[fxx + fyy*head.biWidth] == back) &&
+								fxx>=localbox.left && fxx<=localbox.right && fyy>=localbox.bottom && fyy<=localbox.top )
+							{
+								plocal[fxx + (y + fy)*head.biWidth] = mark;
+								if (fyy > 0 && plocal[fxx + (fyy - 1)*head.biWidth] == back){
+									pix[last].x = fx;
+									pix[last].y = fy - 1;
+									last++;
+									if (last == npix) last = 0;
+								}
+								if ((fyy + 1)<head.biHeight && plocal[fxx + (fyy + 1)*head.biWidth] == back){
+									pix[last].x = fx;
+									pix[last].y = fy + 1;
+									last++;
+									if (last == npix) last = 0;
+								}
+							} else {
+								break;
+							}
+							fx--;
+							fxx--;
+						} while(1);
+						
+						first++;
+						if (first == npix) first = 0;
+					}
+				}
+			}
+		}
+	}
+
+	//transfer the region
+	long yoffset;
+	for (y=localbox.bottom; y<=localbox.top; y++){
+		yoffset = y * head.biWidth;
+		for (x=localbox.left; x<=localbox.right; x++)
+			if (plocal[x + yoffset]!=1) pSelection[x + yoffset]=255;
+	}
+	if (info.rSelectionBox.top < localbox.top) info.rSelectionBox.top = localbox.top+1;
+	if (info.rSelectionBox.left > localbox.left) info.rSelectionBox.left = localbox.left;
+	if (info.rSelectionBox.right < localbox.right) info.rSelectionBox.right = localbox.right+1;
+	if (info.rSelectionBox.bottom > localbox.bottom) info.rSelectionBox.bottom = localbox.bottom;
+
+	free(plocal);
+	free(pix);
+
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Adds to the selection all the pixels matching the specified color.
+ */
+bool CxImage::SelectionAddColor(RGBQUAD c)
+{
+    if (pSelection==NULL) SelectionCreate();
+	if (pSelection==NULL) return false;
+
+	RECT localbox = {head.biWidth,0,0,head.biHeight};
+
+    for (long y = 0; y < head.biHeight; y++){
+        for (long x = 0; x < head.biWidth; x++){
+            RGBQUAD color = GetPixelColor(x, y);
+            if (color.rgbRed   == c.rgbRed &&
+				color.rgbGreen == c.rgbGreen &&
+                color.rgbBlue  == c.rgbBlue)
+            {
+                pSelection[x + y * head.biWidth] = 255; // set the correct mask bit
+
+				if (localbox.top < y) localbox.top = y;
+				if (localbox.left > x) localbox.left = x;
+				if (localbox.right < x) localbox.right = x;
+				if (localbox.bottom > y) localbox.bottom = y;
+            }
+        }
+    }
+
+	if (info.rSelectionBox.top < localbox.top) info.rSelectionBox.top = localbox.top;
+	if (info.rSelectionBox.left > localbox.left) info.rSelectionBox.left = localbox.left;
+	if (info.rSelectionBox.right < localbox.right) info.rSelectionBox.right = localbox.right;
+	if (info.rSelectionBox.bottom > localbox.bottom) info.rSelectionBox.bottom = localbox.bottom;
+
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Adds a single pixel to the existing selection.
+ */
+bool CxImage::SelectionAddPixel(int x, int y)
+{
+    if (pSelection==NULL) SelectionCreate();
+	if (pSelection==NULL) return false;
+
+    if (IsInside(x,y)) {
+        pSelection[x + y * head.biWidth] = 255; // set the correct mask bit
+        return true;
+    }
+
+    return false;
+}
+////////////////////////////////////////////////////////////////////////////////
+/**
+ * Exports the selection channel in a 8bpp grayscale image.
+ */
+bool CxImage::SelectionSplit(CxImage *dest)
+{
+	if (!pSelection || !dest) return false;
+
+	CxImage tmp(head.biWidth,head.biHeight,8);
+	if (!tmp.IsValid()) return false;
+
+	for(long y=0; y<head.biHeight; y++){
+		for(long x=0; x<head.biWidth; x++){
+			tmp.SetPixelIndex(x,y,pSelection[x+y*head.biWidth]);
+		}
+	}
+
+	tmp.SetGrayPalette();
+	dest->Transfer(tmp);
+
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#if CXIMAGE_SUPPORT_WINDOWS
+/**
+ * Converts the selection in a HRGN object.
+ */
+bool CxImage::SelectionToHRGN(HRGN& region)
+{
+	if (pSelection && region){           
+        for(int y = 0; y < head.biHeight; y++){
+            HRGN hTemp = NULL;
+            int iStart = -1;
+            int x = 0;
+			for(; x < head.biWidth; x++){
+                if (pSelection[x + y * head.biWidth] == 255){
+					if (iStart == -1) iStart = x;
+					continue;
+                }else{
+                    if (iStart >= 0){
+                        hTemp = CreateRectRgn(iStart, y, x, y + 1);
+                        CombineRgn(region, hTemp, region, RGN_OR);
+                        DeleteObject(hTemp);
+                        iStart = -1;
+                    }
+                }
+            }
+            if (iStart >= 0){
+                hTemp = CreateRectRgn(iStart, y, x, y + 1);
+                CombineRgn(region, hTemp, region, RGN_OR);
+                DeleteObject(hTemp);
+                iStart = -1;
+            }
+        }
+		return true;
+    }
+	return false;
+}
+#endif //CXIMAGE_SUPPORT_WINDOWS
+////////////////////////////////////////////////////////////////////////////////
+#endif //CXIMAGE_SUPPORT_SELECTION
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximatga.cpp ./win32/dependencies/cximage/ximatga.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximatga.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximatga.cpp	2006-08-24 07:16:03 +0900
@@ -0,0 +1,300 @@
+/*
+ * File:	ximatga.cpp
+ * Purpose:	Platform Independent TGA Image Class Loader and Writer
+ * 05/Jan/2001 Davide Pizzolato - www.xdp.it
+ * CxImage version 5.99c 17/Oct/2004
+ */
+
+#include "ximatga.h"
+
+#if CXIMAGE_SUPPORT_TGA
+
+#include "ximaiter.h"
+
+// Definitions for image types.
+#define TGA_Null 0
+#define TGA_Map 1
+#define TGA_RGB 2
+#define TGA_Mono 3
+#define TGA_RLEMap 9
+#define TGA_RLERGB 10
+#define TGA_RLEMono 11
+#define TGA_CompMap 32
+#define TGA_CompMap4 33
+
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageTGA::Decode(CxFile *hFile)
+{
+	if (hFile == NULL) return false;
+
+	TGAHEADER tgaHead;
+
+  try
+  {
+	if (hFile->Read(&tgaHead,sizeof(tgaHead),1)==0)
+		throw "Not a TGA";
+
+	bool bCompressed;
+	switch (tgaHead.ImageType){
+	case TGA_Map:
+	case TGA_RGB:
+	case TGA_Mono:
+		bCompressed = false;
+		break;
+	case TGA_RLEMap:
+	case TGA_RLERGB:
+	case TGA_RLEMono:
+		bCompressed = true;
+		break;
+	default:
+		throw "Unknown TGA image type";
+	}
+
+	if (tgaHead.ImageWidth==0 || tgaHead.ImageHeight==0 || tgaHead.PixelDepth==0 || tgaHead.CmapLength>256)
+		throw "bad TGA header";
+
+	if (tgaHead.PixelDepth!=8 && tgaHead.PixelDepth!=15 && tgaHead.PixelDepth!=16 && tgaHead.PixelDepth!=24 && tgaHead.PixelDepth!=32)
+		throw "bad TGA header";
+
+	if (tgaHead.IdLength>0) hFile->Seek(tgaHead.IdLength,SEEK_CUR); //skip descriptor
+
+	Create(tgaHead.ImageWidth, tgaHead.ImageHeight, tgaHead.PixelDepth, CXIMAGE_FORMAT_TGA);
+#if CXIMAGE_SUPPORT_ALPHA	// <vho>
+	if (tgaHead.PixelDepth==32) AlphaCreate(); // Image has alpha channel
+#endif //CXIMAGE_SUPPORT_ALPHA
+
+	if (!IsValid()) throw "TGA Create failed";
+	
+	if (info.nEscape) throw "Cancelled"; // <vho> - cancel decoding
+
+	if (tgaHead.CmapType != 0){ // read the palette
+		rgb_color pal[256];
+		hFile->Read(pal,tgaHead.CmapLength*sizeof(rgb_color), 1);
+		for (int i=0;i<tgaHead.CmapLength; i++) SetPaletteColor((BYTE)i,pal[i].b,pal[i].g,pal[i].r);
+	}
+
+	if (tgaHead.ImageType == TGA_Mono || tgaHead.ImageType == TGA_RLEMono)
+		SetGrayPalette();
+
+	// Bits 4 & 5 of the Image Descriptor byte control the ordering of the pixels.
+	bool bXReversed = ((tgaHead.ImagDesc & 16) == 16);
+	bool bYReversed = ((tgaHead.ImagDesc & 32) == 32);
+
+    CImageIterator iter(this);
+	BYTE rleLeftover = 255; //for images with illegal packet boundary 
+	BYTE* pDest;
+    for (int y=0; y < tgaHead.ImageHeight; y++){
+
+		if (info.nEscape) throw "Cancelled"; // <vho> - cancel decoding
+
+		if (hFile == NULL || hFile->Eof()) throw "corrupted TGA";
+
+		if (bYReversed) pDest = iter.GetRow(tgaHead.ImageHeight-y-1);
+		else pDest = iter.GetRow(y);
+
+		if (bCompressed) rleLeftover = ExpandCompressedLine(pDest,&tgaHead,hFile,tgaHead.ImageWidth,y,rleLeftover);
+		else ExpandUncompressedLine  (pDest,&tgaHead,hFile,tgaHead.ImageWidth,y,0);
+    }
+
+	if (bXReversed) Mirror();
+
+#if CXIMAGE_SUPPORT_ALPHA
+	if (bYReversed && tgaHead.PixelDepth==32) AlphaFlip(); //<lioucr>
+#endif //CXIMAGE_SUPPORT_ALPHA
+
+  } catch (char *message) {
+	strncpy(info.szLastError,message,255);
+	return FALSE;
+  }
+    return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#if CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+bool CxImageTGA::Encode(CxFile * hFile)
+{
+	if (EncodeSafeCheck(hFile)) return false;
+
+	if (head.biBitCount<8){
+		strcpy(info.szLastError,"Bit depth must be 8 or 24");
+		return false;
+	}
+
+	TGAHEADER tgaHead;
+
+    tgaHead.IdLength = 0;				// Image ID Field Length
+    tgaHead.CmapType = GetPalette()!=0; // Color Map Type
+    tgaHead.ImageType = (head.biBitCount == 8) ? (BYTE)TGA_Map : (BYTE)TGA_RGB; // Image Type
+
+    tgaHead.CmapIndex=0;				// First Entry Index
+    tgaHead.CmapLength=(head.biBitCount == 8) ? 256 : 0;   // Color Map Length
+    tgaHead.CmapEntrySize=(head.biBitCount == 8) ? (BYTE)24 : (BYTE)0; // Color Map Entry Size
+
+    tgaHead.X_Origin=0;					// X-origin of Image
+    tgaHead.Y_Origin=0;					// Y-origin of Image
+    tgaHead.ImageWidth=(WORD)head.biWidth;		// Image Width
+    tgaHead.ImageHeight=(WORD)head.biHeight;	// Image Height
+    tgaHead.PixelDepth=(BYTE)head.biBitCount;	// Pixel Depth
+    tgaHead.ImagDesc=0;					// Image Descriptor
+
+	if (pAlpha && head.biBitCount==24) tgaHead.PixelDepth=32; 
+
+	hFile->Write(&tgaHead,sizeof(TGAHEADER),1);
+
+	if (head.biBitCount==8){
+		rgb_color pal[256];
+		RGBQUAD* ppal = GetPalette();
+		for (int i=0;i<256; i++){
+			pal[i].r = ppal[i].rgbBlue;
+			pal[i].g = ppal[i].rgbGreen;
+			pal[i].b = ppal[i].rgbRed;
+		}
+		hFile->Write(&pal,256*sizeof(rgb_color),1);
+	}
+	
+	CImageIterator iter(this);
+	BYTE* pDest;
+	if (pAlpha==0 || head.biBitCount==8){
+		for (int y=0; y < tgaHead.ImageHeight; y++){
+			pDest = iter.GetRow(y);
+			hFile->Write(pDest,tgaHead.ImageWidth * (head.biBitCount >> 3),1);
+		}
+	} else {
+		pDest = (BYTE*)malloc(4*tgaHead.ImageWidth);
+		RGBQUAD c;
+		for (int y=0; y < tgaHead.ImageHeight; y++){
+			for(int x=0, x4=0;x<tgaHead.ImageWidth;x++, x4+=4){
+				c=GetPixelColor(x,y);
+				pDest[x4+0]=c.rgbBlue;
+				pDest[x4+1]=c.rgbGreen;
+				pDest[x4+2]=c.rgbRed;
+#if CXIMAGE_SUPPORT_ALPHA	// <vho>
+				pDest[x4+3]=(BYTE)((AlphaGet(x,y)*info.nAlphaMax)/255);
+#else
+				pDest[x4+3]=0;
+#endif //CXIMAGE_SUPPORT_ALPHA
+			}
+			hFile->Write(pDest,4*tgaHead.ImageWidth,1);
+		}
+		free(pDest);
+	}
+	return true;
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif // CXIMAGE_SUPPORT_ENCODE
+////////////////////////////////////////////////////////////////////////////////
+BYTE CxImageTGA::ExpandCompressedLine(BYTE* pDest,TGAHEADER* ptgaHead,CxFile *hFile,int width, int y, BYTE rleLeftover)
+{
+	try{
+	BYTE rle;
+	long filePos;
+	for (int x=0; x<width; ){
+		if (rleLeftover != 255){
+            rle = rleLeftover;
+            rleLeftover = 255;
+        } else {
+			hFile->Read(&rle,1,1);
+		}
+		if (rle & 128) { // RLE-Encoded packet
+			rle -= 127; // Calculate real repeat count.
+			if ((x+rle)>width){
+				rleLeftover = 128 + (rle - (width - x) - 1);
+                filePos = hFile->Tell();
+				rle=width-x;
+			}
+			switch (ptgaHead->PixelDepth)
+			{
+			case 32: {
+				RGBQUAD color;
+				hFile->Read(&color,4,1);
+				for (int ix = 0; ix < rle; ix++){
+					memcpy(&pDest[3*ix],&color,3);
+#if CXIMAGE_SUPPORT_ALPHA	// <vho>
+					AlphaSet(ix+x,y,color.rgbReserved);
+#endif //CXIMAGE_SUPPORT_ALPHA
+				}
+				break;
+					 } 
+			case 24: {
+				rgb_color triple;
+				hFile->Read(&triple,3,1);
+				for (int ix = 0; ix < rle; ix++) memcpy(&pDest[3*ix],&triple,3);
+				break;
+					 }
+			case 15:
+			case 16: {
+				WORD pixel;
+				hFile->Read(&pixel,2,1);
+				rgb_color triple;
+				triple.r = (BYTE)(( pixel & 0x1F ) * 8);     // red
+				triple.g = (BYTE)(( pixel >> 2 ) & 0x0F8);   // green
+				triple.b = (BYTE)(( pixel >> 7 ) & 0x0F8);   // blue
+				for (int ix = 0; ix < rle; ix++){
+					memcpy(&pDest[3*ix],&triple,3);
+				}
+				break;
+					 }
+			case 8: {
+				BYTE pixel;
+				hFile->Read(&pixel,1,1);
+				for (int ix = 0; ix < rle; ix++) pDest[ix] = pixel;
+					}
+			}
+			if (rleLeftover!=255) hFile->Seek(filePos, SEEK_SET);
+		} else { // Raw packet
+			rle += 1; // Calculate real repeat count.
+			if ((x+rle)>width){
+                rleLeftover = rle - (width - x) - 1;
+				rle=width-x;
+			}
+			ExpandUncompressedLine(pDest,ptgaHead,hFile,rle,y,x);
+		}
+		if (head.biBitCount == 24)	pDest += rle*3;	else pDest += rle;
+		x += rle;
+	}
+	} catch(...){	}
+	return rleLeftover;
+}
+////////////////////////////////////////////////////////////////////////////////
+void CxImageTGA::ExpandUncompressedLine(BYTE* pDest,TGAHEADER* ptgaHead,CxFile *hFile,int width, int y, int xoffset)
+{
+	try{
+	switch (ptgaHead->PixelDepth){
+	case 8:
+		hFile->Read(pDest,width,1);
+		break;
+	case 15:
+	case 16:{
+		BYTE* dst=pDest;
+		WORD pixel;
+		for (int x=0; x<width; x++){
+			hFile->Read(&pixel,2,1);
+			*dst++ = (BYTE)(( pixel & 0x1F ) * 8);     // blue
+			*dst++ = (BYTE)(( pixel >> 2 ) & 0x0F8);   // green
+			*dst++ = (BYTE)(( pixel >> 7 ) & 0x0F8);   // red
+		}
+		break;
+			}
+	case 24:
+		hFile->Read(pDest,3*width,1);
+		break;
+	case 32:{
+		BYTE* dst=pDest;
+		for (int x=0; x<width; x++){
+			RGBQUAD pixel;
+			hFile->Read(&pixel,4,1);
+			*dst++ = pixel.rgbBlue;
+			*dst++ = pixel.rgbGreen;
+			*dst++ = pixel.rgbRed;
+#if CXIMAGE_SUPPORT_ALPHA	// <vho>
+			AlphaSet(x+xoffset,y,pixel.rgbReserved); //alpha
+#endif //CXIMAGE_SUPPORT_ALPHA
+		}
+		break;
+			}
+	}
+	} catch(...){	}
+}
+////////////////////////////////////////////////////////////////////////////////
+#endif 	// CXIMAGE_SUPPORT_TGA
+
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximatga.h ./win32/dependencies/cximage/ximatga.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximatga.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximatga.h	2006-08-24 07:16:03 +0900
@@ -0,0 +1,60 @@
+/*
+ * File:	ximatga.h
+ * Purpose:	TARGA Image Class Loader and Writer
+ */
+/* ==========================================================
+ * CxImageTGA (c) 05/Jan/2002 Davide Pizzolato - www.xdp.it
+ * For conditions of distribution and use, see copyright notice in ximage.h
+ *
+ * Parts of the code come from Paintlib : Copyright (c) 1996-1998 Ulrich von Zadow
+ * ==========================================================
+ */
+#if !defined(__ximaTGA_h)
+#define __ximaTGA_h
+
+#include "ximage.h"
+
+#if CXIMAGE_SUPPORT_TGA
+
+class CxImageTGA: public CxImage
+{
+#pragma pack(1)
+typedef struct tagTgaHeader
+{
+    BYTE   IdLength;            // Image ID Field Length
+    BYTE   CmapType;            // Color Map Type
+    BYTE   ImageType;           // Image Type
+
+    WORD   CmapIndex;           // First Entry Index
+    WORD   CmapLength;          // Color Map Length
+    BYTE   CmapEntrySize;       // Color Map Entry Size
+
+    WORD   X_Origin;            // X-origin of Image
+    WORD   Y_Origin;            // Y-origin of Image
+    WORD   ImageWidth;          // Image Width
+    WORD   ImageHeight;         // Image Height
+    BYTE   PixelDepth;          // Pixel Depth
+    BYTE   ImagDesc;            // Image Descriptor
+} TGAHEADER;
+#pragma pack()
+
+public:
+	CxImageTGA(): CxImage(CXIMAGE_FORMAT_TGA) {}
+
+//	bool Load(const char * imageFileName){ return CxImage::Load(imageFileName,CXIMAGE_FORMAT_TGA);}
+//	bool Save(const char * imageFileName){ return CxImage::Save(imageFileName,CXIMAGE_FORMAT_TGA);}
+	bool Decode(CxFile * hFile);
+	bool Decode(FILE *hFile) { CxIOFile file(hFile); return Decode(&file); }
+
+#if CXIMAGE_SUPPORT_ENCODE
+	bool Encode(CxFile * hFile);
+	bool Encode(FILE *hFile) { CxIOFile file(hFile); return Encode(&file); }
+#endif // CXIMAGE_SUPPORT_ENCODE
+protected:
+	BYTE ExpandCompressedLine(BYTE* pDest,TGAHEADER* ptgaHead,CxFile *hFile,int width, int y, BYTE rleLeftover);
+	void ExpandUncompressedLine(BYTE* pDest,TGAHEADER* ptgaHead,CxFile *hFile,int width, int y, int xoffset);
+};
+
+#endif
+
+#endif
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximath.cpp ./win32/dependencies/cximage/ximath.cpp
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximath.cpp	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximath.cpp	2006-08-24 07:16:03 +0900
@@ -0,0 +1,97 @@
+#include "ximage.h"
+#include "ximath.h"
+#include <math.h>
+
+//this module should contain some classes for geometrical transformations
+//usable with selections, etc... once it's done, that is. :)
+
+CxPoint2::CxPoint2()
+{
+  x=y=0.0f;
+}
+
+CxPoint2::CxPoint2(float const x_, float const y_)
+{
+  x=x_;
+  y=y_;
+}
+
+CxPoint2::CxPoint2(CxPoint2 const &p)
+{
+  x=p.x;
+  y=p.y;
+}
+
+float CxPoint2::Distance(CxPoint2 const p2)
+{
+  return (float)sqrt((x-p2.x)*(x-p2.x)+(y-p2.y)*(y-p2.y));
+}
+
+float CxPoint2::Distance(float const x_, float const y_)
+{
+  return (float)sqrt((x-x_)*(x-x_)+(y-y_)*(y-y_));
+}
+
+CxRect2::CxRect2()
+{
+}
+
+CxRect2::CxRect2(float const x1_, float const y1_, float const x2_, float const y2_)
+{
+  botLeft.x=x1_;
+  botLeft.y=y1_;
+  topRight.x=x2_;
+  topRight.y=y2_;
+}
+
+CxRect2::CxRect2(CxRect2 const &p)
+{
+  botLeft=p.botLeft;
+  topRight=p.topRight;
+}
+
+float CxRect2::Surface() const
+/*
+ * Returns the surface of rectangle.
+ */
+{
+  return (topRight.x-botLeft.x)*(topRight.y-botLeft.y);
+}
+
+CxRect2 CxRect2::CrossSection(CxRect2 const &r2) const
+/*
+ * Returns crossection with another rectangle.
+ */
+{
+  CxRect2 cs;
+  cs.botLeft.x=max(botLeft.x, r2.botLeft.x);
+  cs.botLeft.y=max(botLeft.y, r2.botLeft.y);
+  cs.topRight.x=min(topRight.x, r2.topRight.x);
+  cs.topRight.y=min(topRight.y, r2.topRight.y);
+  if (cs.botLeft.x<=cs.topRight.x && cs.botLeft.y<=cs.topRight.y) {
+    return cs;
+  } else {
+    return CxRect2(0,0,0,0);
+  }//if
+}
+
+CxPoint2 CxRect2::Center() const
+/*
+ * Returns the center point of rectangle.
+ */
+{
+  return CxPoint2((topRight.x+botLeft.x)/2.0f, (topRight.y+botLeft.y)/2.0f);
+}
+
+float CxRect2::Width() const
+//returns rectangle width
+{
+  return topRight.x-botLeft.x;
+}
+
+float CxRect2::Height() const
+//returns rectangle height
+{
+  return topRight.y-botLeft.y;
+}
+
diff -urN ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximath.h ./win32/dependencies/cximage/ximath.h
--- ../VisualBoyAdvance-1.7.2/win32/dependencies/cximage/ximath.h	1970-01-01 09:00:00 +0900
+++ ./win32/dependencies/cximage/ximath.h	2006-08-24 07:16:03 +0900
@@ -0,0 +1,39 @@
+#if !defined(__ximath_h)
+#define __ximath_h
+
+#include "ximadef.h"
+
+//***bd*** simple floating point point
+class DLL_EXP CxPoint2
+{
+public:
+  CxPoint2();
+  CxPoint2(float const x_, float const y_);
+  CxPoint2(CxPoint2 const &p);
+
+  float Distance(CxPoint2 const p2);
+  float Distance(float const x_, float const y_);
+
+  float x,y;
+};
+
+//and simple rectangle
+class DLL_EXP CxRect2
+{
+public:
+  CxRect2();
+  CxRect2(float const x1_, float const y1_, float const x2_, float const y2_);
+  CxRect2(CxPoint2 const &bl, CxPoint2 const &tr);
+  CxRect2(CxRect2 const &p);
+
+  float Surface() const;
+  CxRect2 CrossSection(CxRect2 const &r2) const;
+  CxPoint2 Center() const;
+  float Width() const;
+  float Height() const;
+
+  CxPoint2 botLeft;
+  CxPoint2 topRight;
+};
+
+#endif
